#include "header.h"

void eval_jacob_3 (const double mw_avg, const double rho, const double cp_avg, const double* spec_rates, const double* h, const double* cp, double* jac) {
  double rho_inv = 1.0 / rho;
  double working_temp = (1.0 / cp_avg);
  double j_temp = 1.0 / (rho * cp_avg * cp_avg);
  jac[22] += (spec_rates[0] * mw_avg * 9.2803892982949643e-01 * rho_inv);
  jac[21] = -(h[0] * (working_temp * jac[22] - (j_temp * (cp[0] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[43] += (spec_rates[0] * mw_avg * 1.9280389298294964e+00 * rho_inv);
  jac[42] = -(h[0] * (working_temp * jac[43] - (j_temp * (cp[1] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[64] += (spec_rates[0] * mw_avg * 5.4036154725429976e-02 * rho_inv);
  jac[63] = -(h[0] * (working_temp * jac[64] - (j_temp * (cp[2] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[85] += (spec_rates[0] * mw_avg * -8.9624577225368204e-03 * rho_inv);
  jac[84] = -(h[0] * (working_temp * jac[85] - (j_temp * (cp[3] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[106] += (spec_rates[0] * mw_avg * 4.6568929229755335e-02 * rho_inv);
  jac[105] = -(h[0] * (working_temp * jac[106] - (j_temp * (cp[4] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[127] += (spec_rates[0] * mw_avg * 3.9937273901861609e-02 * rho_inv);
  jac[126] = -(h[0] * (working_temp * jac[127] - (j_temp * (cp[5] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[148] += (spec_rates[0] * mw_avg * -1.0886271508169818e-02 * rho_inv);
  jac[147] = -(h[0] * (working_temp * jac[148] - (j_temp * (cp[6] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[169] += (spec_rates[0] * mw_avg * 7.1754424650867926e-02 * rho_inv);
  jac[168] = -(h[0] * (working_temp * jac[169] - (j_temp * (cp[7] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[190] += (spec_rates[0] * mw_avg * 7.1754424650867926e-02 * rho_inv);
  jac[189] = -(h[0] * (working_temp * jac[190] - (j_temp * (cp[8] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[211] += (spec_rates[0] * mw_avg * 6.2119683706164004e-02 * rho_inv);
  jac[210] = -(h[0] * (working_temp * jac[211] - (j_temp * (cp[9] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[232] += (spec_rates[0] * mw_avg * 5.3695612345472425e-02 * rho_inv);
  jac[231] = -(h[0] * (working_temp * jac[232] - (j_temp * (cp[10] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[253] += (spec_rates[0] * mw_avg * 7.9127786866828727e-06 * rho_inv);
  jac[252] = -(h[0] * (working_temp * jac[253] - (j_temp * (cp[11] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[274] += (spec_rates[0] * mw_avg * -2.6155817704007524e-02 * rho_inv);
  jac[273] = -(h[0] * (working_temp * jac[274] - (j_temp * (cp[12] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[295] += (spec_rates[0] * mw_avg * -2.4918999836493717e-03 * rho_inv);
  jac[294] = -(h[0] * (working_temp * jac[295] - (j_temp * (cp[13] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[316] += (spec_rates[0] * mw_avg * -4.8238823470369866e-03 * rho_inv);
  jac[315] = -(h[0] * (working_temp * jac[316] - (j_temp * (cp[14] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[337] += (spec_rates[0] * mw_avg * -7.0043868705850091e-03 * rho_inv);
  jac[336] = -(h[0] * (working_temp * jac[337] - (j_temp * (cp[15] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[358] += (spec_rates[0] * mw_avg * -1.0332275981785601e-04 * rho_inv);
  jac[357] = -(h[0] * (working_temp * jac[358] - (j_temp * (cp[16] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[379] += (spec_rates[0] * mw_avg * -2.5955478507494450e-03 * rho_inv);
  jac[378] = -(h[0] * (working_temp * jac[379] - (j_temp * (cp[17] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[400] += (spec_rates[0] * mw_avg * -4.9206932321698071e-03 * rho_inv);
  jac[399] = -(h[0] * (working_temp * jac[400] - (j_temp * (cp[18] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[421] += (spec_rates[0] * mw_avg * -2.1498468788707290e-02 * rho_inv);
  jac[420] = -(h[0] * (working_temp * jac[421] - (j_temp * (cp[19] - cp[20]) * spec_rates[0] * 2.01588000e+00)));
  jac[23] += (spec_rates[1] * mw_avg * 4.6401946491474821e-01 * rho_inv);
  jac[21] -= (h[1] * (working_temp * jac[23] - (j_temp * (cp[0] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[44] += (spec_rates[1] * mw_avg * 9.6401946491474821e-01 * rho_inv);
  jac[42] -= (h[1] * (working_temp * jac[44] - (j_temp * (cp[1] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[65] += (spec_rates[1] * mw_avg * 2.7018077362714988e-02 * rho_inv);
  jac[63] -= (h[1] * (working_temp * jac[65] - (j_temp * (cp[2] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[86] += (spec_rates[1] * mw_avg * -4.4812288612684102e-03 * rho_inv);
  jac[84] -= (h[1] * (working_temp * jac[86] - (j_temp * (cp[3] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[107] += (spec_rates[1] * mw_avg * 2.3284464614877667e-02 * rho_inv);
  jac[105] -= (h[1] * (working_temp * jac[107] - (j_temp * (cp[4] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[128] += (spec_rates[1] * mw_avg * 1.9968636950930804e-02 * rho_inv);
  jac[126] -= (h[1] * (working_temp * jac[128] - (j_temp * (cp[5] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[149] += (spec_rates[1] * mw_avg * -5.4431357540849091e-03 * rho_inv);
  jac[147] -= (h[1] * (working_temp * jac[149] - (j_temp * (cp[6] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[170] += (spec_rates[1] * mw_avg * 3.5877212325433963e-02 * rho_inv);
  jac[168] -= (h[1] * (working_temp * jac[170] - (j_temp * (cp[7] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[191] += (spec_rates[1] * mw_avg * 3.5877212325433963e-02 * rho_inv);
  jac[189] -= (h[1] * (working_temp * jac[191] - (j_temp * (cp[8] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[212] += (spec_rates[1] * mw_avg * 3.1059841853082002e-02 * rho_inv);
  jac[210] -= (h[1] * (working_temp * jac[212] - (j_temp * (cp[9] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[233] += (spec_rates[1] * mw_avg * 2.6847806172736213e-02 * rho_inv);
  jac[231] -= (h[1] * (working_temp * jac[233] - (j_temp * (cp[10] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[254] += (spec_rates[1] * mw_avg * 3.9563893433414364e-06 * rho_inv);
  jac[252] -= (h[1] * (working_temp * jac[254] - (j_temp * (cp[11] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[275] += (spec_rates[1] * mw_avg * -1.3077908852003762e-02 * rho_inv);
  jac[273] -= (h[1] * (working_temp * jac[275] - (j_temp * (cp[12] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[296] += (spec_rates[1] * mw_avg * -1.2459499918246859e-03 * rho_inv);
  jac[294] -= (h[1] * (working_temp * jac[296] - (j_temp * (cp[13] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[317] += (spec_rates[1] * mw_avg * -2.4119411735184933e-03 * rho_inv);
  jac[315] -= (h[1] * (working_temp * jac[317] - (j_temp * (cp[14] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[338] += (spec_rates[1] * mw_avg * -3.5021934352925045e-03 * rho_inv);
  jac[336] -= (h[1] * (working_temp * jac[338] - (j_temp * (cp[15] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[359] += (spec_rates[1] * mw_avg * -5.1661379908928005e-05 * rho_inv);
  jac[357] -= (h[1] * (working_temp * jac[359] - (j_temp * (cp[16] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[380] += (spec_rates[1] * mw_avg * -1.2977739253747225e-03 * rho_inv);
  jac[378] -= (h[1] * (working_temp * jac[380] - (j_temp * (cp[17] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[401] += (spec_rates[1] * mw_avg * -2.4603466160849036e-03 * rho_inv);
  jac[399] -= (h[1] * (working_temp * jac[401] - (j_temp * (cp[18] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[422] += (spec_rates[1] * mw_avg * -1.0749234394353645e-02 * rho_inv);
  jac[420] -= (h[1] * (working_temp * jac[422] - (j_temp * (cp[19] - cp[20]) * spec_rates[1] * 1.00794000e+00)));
  jac[24] += (spec_rates[2] * mw_avg * 7.3655505555459868e+00 * rho_inv);
  jac[21] -= (h[2] * (working_temp * jac[24] - (j_temp * (cp[0] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[45] += (spec_rates[2] * mw_avg * 1.5302233294597915e+01 * rho_inv);
  jac[42] -= (h[2] * (working_temp * jac[45] - (j_temp * (cp[1] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[66] += (spec_rates[2] * mw_avg * 4.2886781649405936e-01 * rho_inv);
  jac[63] -= (h[2] * (working_temp * jac[66] - (j_temp * (cp[2] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[87] += (spec_rates[2] * mw_avg * -7.1132183505940638e-02 * rho_inv);
  jac[84] -= (h[2] * (working_temp * jac[87] - (j_temp * (cp[3] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[108] += (spec_rates[2] * mw_avg * 3.6960281679392992e-01 * rho_inv);
  jac[105] -= (h[2] * (working_temp * jac[108] - (j_temp * (cp[4] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[129] += (spec_rates[2] * mw_avg * 3.1696947242169404e-01 * rho_inv);
  jac[126] -= (h[2] * (working_temp * jac[129] - (j_temp * (cp[5] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[150] += (spec_rates[2] * mw_avg * -8.6400883171524182e-02 * rho_inv);
  jac[147] -= (h[2] * (working_temp * jac[150] - (j_temp * (cp[6] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[171] += (spec_rates[2] * mw_avg * 5.6949210357714553e-01 * rho_inv);
  jac[168] -= (h[2] * (working_temp * jac[171] - (j_temp * (cp[7] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[192] += (spec_rates[2] * mw_avg * 5.6949210357714553e-01 * rho_inv);
  jac[189] -= (h[2] * (working_temp * jac[192] - (j_temp * (cp[8] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[213] += (spec_rates[2] * mw_avg * 4.9302422142607716e-01 * rho_inv);
  jac[210] -= (h[2] * (working_temp * jac[213] - (j_temp * (cp[9] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[234] += (spec_rates[2] * mw_avg * 4.2616503966513453e-01 * rho_inv);
  jac[231] -= (h[2] * (working_temp * jac[234] - (j_temp * (cp[10] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[255] += (spec_rates[2] * mw_avg * 6.2801214020533931e-05 * rho_inv);
  jac[252] -= (h[2] * (working_temp * jac[255] - (j_temp * (cp[11] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[276] += (spec_rates[2] * mw_avg * -2.0759042689718529e-01 * rho_inv);
  jac[273] -= (h[2] * (working_temp * jac[276] - (j_temp * (cp[12] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[297] += (spec_rates[2] * mw_avg * -1.9777419587673751e-02 * rho_inv);
  jac[294] -= (h[2] * (working_temp * jac[297] - (j_temp * (cp[13] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[318] += (spec_rates[2] * mw_avg * -3.8285623758945744e-02 * rho_inv);
  jac[315] -= (h[2] * (working_temp * jac[318] - (j_temp * (cp[14] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[339] += (spec_rates[2] * mw_avg * -5.5591596373413973e-02 * rho_inv);
  jac[336] -= (h[2] * (working_temp * jac[339] - (j_temp * (cp[15] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[360] += (spec_rates[2] * mw_avg * -8.2003996439758593e-04 * rho_inv);
  jac[357] -= (h[2] * (working_temp * jac[360] - (j_temp * (cp[16] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[381] += (spec_rates[2] * mw_avg * -2.0600039825426453e-02 * rho_inv);
  jac[378] -= (h[2] * (working_temp * jac[381] - (j_temp * (cp[17] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[402] += (spec_rates[2] * mw_avg * -3.9053981039931747e-02 * rho_inv);
  jac[399] -= (h[2] * (working_temp * jac[402] - (j_temp * (cp[18] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[423] += (spec_rates[2] * mw_avg * -1.7062652615137971e-01 * rho_inv);
  jac[420] -= (h[2] * (working_temp * jac[423] - (j_temp * (cp[19] - cp[20]) * spec_rates[2] * 1.59994000e+01)));
  jac[25] += (spec_rates[3] * mw_avg * 1.4731101111091974e+01 * rho_inv);
  jac[21] -= (h[3] * (working_temp * jac[25] - (j_temp * (cp[0] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[46] += (spec_rates[3] * mw_avg * 3.0604466589195830e+01 * rho_inv);
  jac[42] -= (h[3] * (working_temp * jac[46] - (j_temp * (cp[1] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[67] += (spec_rates[3] * mw_avg * 8.5773563298811872e-01 * rho_inv);
  jac[63] -= (h[3] * (working_temp * jac[67] - (j_temp * (cp[2] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[88] += (spec_rates[3] * mw_avg * -1.4226436701188128e-01 * rho_inv);
  jac[84] -= (h[3] * (working_temp * jac[88] - (j_temp * (cp[3] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[109] += (spec_rates[3] * mw_avg * 7.3920563358785984e-01 * rho_inv);
  jac[105] -= (h[3] * (working_temp * jac[109] - (j_temp * (cp[4] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[130] += (spec_rates[3] * mw_avg * 6.3393894484338809e-01 * rho_inv);
  jac[126] -= (h[3] * (working_temp * jac[130] - (j_temp * (cp[5] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[151] += (spec_rates[3] * mw_avg * -1.7280176634304836e-01 * rho_inv);
  jac[147] -= (h[3] * (working_temp * jac[151] - (j_temp * (cp[6] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[172] += (spec_rates[3] * mw_avg * 1.1389842071542911e+00 * rho_inv);
  jac[168] -= (h[3] * (working_temp * jac[172] - (j_temp * (cp[7] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[193] += (spec_rates[3] * mw_avg * 1.1389842071542911e+00 * rho_inv);
  jac[189] -= (h[3] * (working_temp * jac[193] - (j_temp * (cp[8] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[214] += (spec_rates[3] * mw_avg * 9.8604844285215432e-01 * rho_inv);
  jac[210] -= (h[3] * (working_temp * jac[214] - (j_temp * (cp[9] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[235] += (spec_rates[3] * mw_avg * 8.5233007933026905e-01 * rho_inv);
  jac[231] -= (h[3] * (working_temp * jac[235] - (j_temp * (cp[10] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[256] += (spec_rates[3] * mw_avg * 1.2560242804106786e-04 * rho_inv);
  jac[252] -= (h[3] * (working_temp * jac[256] - (j_temp * (cp[11] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[277] += (spec_rates[3] * mw_avg * -4.1518085379437059e-01 * rho_inv);
  jac[273] -= (h[3] * (working_temp * jac[277] - (j_temp * (cp[12] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[298] += (spec_rates[3] * mw_avg * -3.9554839175347502e-02 * rho_inv);
  jac[294] -= (h[3] * (working_temp * jac[298] - (j_temp * (cp[13] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[319] += (spec_rates[3] * mw_avg * -7.6571247517891489e-02 * rho_inv);
  jac[315] -= (h[3] * (working_temp * jac[319] - (j_temp * (cp[14] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[340] += (spec_rates[3] * mw_avg * -1.1118319274682795e-01 * rho_inv);
  jac[336] -= (h[3] * (working_temp * jac[340] - (j_temp * (cp[15] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[361] += (spec_rates[3] * mw_avg * -1.6400799287951719e-03 * rho_inv);
  jac[357] -= (h[3] * (working_temp * jac[361] - (j_temp * (cp[16] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[382] += (spec_rates[3] * mw_avg * -4.1200079650852907e-02 * rho_inv);
  jac[378] -= (h[3] * (working_temp * jac[382] - (j_temp * (cp[17] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[403] += (spec_rates[3] * mw_avg * -7.8107962079863494e-02 * rho_inv);
  jac[399] -= (h[3] * (working_temp * jac[403] - (j_temp * (cp[18] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[424] += (spec_rates[3] * mw_avg * -3.4125305230275943e-01 * rho_inv);
  jac[420] -= (h[3] * (working_temp * jac[424] - (j_temp * (cp[19] - cp[20]) * spec_rates[3] * 3.19988000e+01)));
  jac[26] += (spec_rates[4] * mw_avg * 7.8295700204607348e+00 * rho_inv);
  jac[21] -= (h[4] * (working_temp * jac[26] - (j_temp * (cp[0] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[47] += (spec_rates[4] * mw_avg * 1.6266252759512660e+01 * rho_inv);
  jac[42] -= (h[4] * (working_temp * jac[47] - (j_temp * (cp[1] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[68] += (spec_rates[4] * mw_avg * 4.5588589385677430e-01 * rho_inv);
  jac[63] -= (h[4] * (working_temp * jac[68] - (j_temp * (cp[2] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[89] += (spec_rates[4] * mw_avg * -7.5613412367209046e-02 * rho_inv);
  jac[84] -= (h[4] * (working_temp * jac[89] - (j_temp * (cp[3] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[110] += (spec_rates[4] * mw_avg * 3.9288728140880758e-01 * rho_inv);
  jac[105] -= (h[4] * (working_temp * jac[110] - (j_temp * (cp[4] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[131] += (spec_rates[4] * mw_avg * 3.3693810937262486e-01 * rho_inv);
  jac[126] -= (h[4] * (working_temp * jac[131] - (j_temp * (cp[5] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[152] += (spec_rates[4] * mw_avg * -9.1844018925609089e-02 * rho_inv);
  jac[147] -= (h[4] * (working_temp * jac[152] - (j_temp * (cp[6] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[173] += (spec_rates[4] * mw_avg * 6.0536931590257959e-01 * rho_inv);
  jac[168] -= (h[4] * (working_temp * jac[173] - (j_temp * (cp[7] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[194] += (spec_rates[4] * mw_avg * 6.0536931590257959e-01 * rho_inv);
  jac[189] -= (h[4] * (working_temp * jac[194] - (j_temp * (cp[8] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[215] += (spec_rates[4] * mw_avg * 5.2408406327915913e-01 * rho_inv);
  jac[210] -= (h[4] * (working_temp * jac[215] - (j_temp * (cp[9] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[236] += (spec_rates[4] * mw_avg * 4.5301284583787071e-01 * rho_inv);
  jac[231] -= (h[4] * (working_temp * jac[236] - (j_temp * (cp[10] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[257] += (spec_rates[4] * mw_avg * 6.6757603363875367e-05 * rho_inv);
  jac[252] -= (h[4] * (working_temp * jac[257] - (j_temp * (cp[11] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[278] += (spec_rates[4] * mw_avg * -2.2066833574918907e-01 * rho_inv);
  jac[273] -= (h[4] * (working_temp * jac[278] - (j_temp * (cp[12] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[299] += (spec_rates[4] * mw_avg * -2.1023369579498435e-02 * rho_inv);
  jac[294] -= (h[4] * (working_temp * jac[299] - (j_temp * (cp[13] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[320] += (spec_rates[4] * mw_avg * -4.0697564932464243e-02 * rho_inv);
  jac[315] -= (h[4] * (working_temp * jac[320] - (j_temp * (cp[14] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[341] += (spec_rates[4] * mw_avg * -5.9093789808706484e-02 * rho_inv);
  jac[336] -= (h[4] * (working_temp * jac[341] - (j_temp * (cp[15] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[362] += (spec_rates[4] * mw_avg * -8.7170134430651397e-04 * rho_inv);
  jac[357] -= (h[4] * (working_temp * jac[362] - (j_temp * (cp[16] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[383] += (spec_rates[4] * mw_avg * -2.1897813750801170e-02 * rho_inv);
  jac[378] -= (h[4] * (working_temp * jac[383] - (j_temp * (cp[17] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[404] += (spec_rates[4] * mw_avg * -4.1514327656016654e-02 * rho_inv);
  jac[399] -= (h[4] * (working_temp * jac[404] - (j_temp * (cp[18] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[425] += (spec_rates[4] * mw_avg * -1.8137576054573337e-01 * rho_inv);
  jac[420] -= (h[4] * (working_temp * jac[425] - (j_temp * (cp[19] - cp[20]) * spec_rates[4] * 1.70073400e+01)));
  jac[27] += (spec_rates[5] * mw_avg * 8.2935894853754846e+00 * rho_inv);
  jac[21] -= (h[5] * (working_temp * jac[27] - (j_temp * (cp[0] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[48] += (spec_rates[5] * mw_avg * 1.7230272224427413e+01 * rho_inv);
  jac[42] -= (h[5] * (working_temp * jac[48] - (j_temp * (cp[1] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[69] += (spec_rates[5] * mw_avg * 4.8290397121948930e-01 * rho_inv);
  jac[63] -= (h[5] * (working_temp * jac[69] - (j_temp * (cp[2] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[90] += (spec_rates[5] * mw_avg * -8.0094641228477453e-02 * rho_inv);
  jac[84] -= (h[5] * (working_temp * jac[90] - (j_temp * (cp[3] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[111] += (spec_rates[5] * mw_avg * 4.1617174602368529e-01 * rho_inv);
  jac[105] -= (h[5] * (working_temp * jac[111] - (j_temp * (cp[4] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[132] += (spec_rates[5] * mw_avg * 3.5690674632355568e-01 * rho_inv);
  jac[126] -= (h[5] * (working_temp * jac[132] - (j_temp * (cp[5] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[153] += (spec_rates[5] * mw_avg * -9.7287154679694010e-02 * rho_inv);
  jac[147] -= (h[5] * (working_temp * jac[153] - (j_temp * (cp[6] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[174] += (spec_rates[5] * mw_avg * 6.4124652822801353e-01 * rho_inv);
  jac[168] -= (h[5] * (working_temp * jac[174] - (j_temp * (cp[7] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[195] += (spec_rates[5] * mw_avg * 6.4124652822801353e-01 * rho_inv);
  jac[189] -= (h[5] * (working_temp * jac[195] - (j_temp * (cp[8] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[216] += (spec_rates[5] * mw_avg * 5.5514390513224121e-01 * rho_inv);
  jac[210] -= (h[5] * (working_temp * jac[216] - (j_temp * (cp[9] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[237] += (spec_rates[5] * mw_avg * 4.7986065201060690e-01 * rho_inv);
  jac[231] -= (h[5] * (working_temp * jac[237] - (j_temp * (cp[10] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[258] += (spec_rates[5] * mw_avg * 7.0713992707216802e-05 * rho_inv);
  jac[252] -= (h[5] * (working_temp * jac[258] - (j_temp * (cp[11] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[279] += (spec_rates[5] * mw_avg * -2.3374624460119284e-01 * rho_inv);
  jac[273] -= (h[5] * (working_temp * jac[279] - (j_temp * (cp[12] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[300] += (spec_rates[5] * mw_avg * -2.2269319571323123e-02 * rho_inv);
  jac[294] -= (h[5] * (working_temp * jac[300] - (j_temp * (cp[13] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[321] += (spec_rates[5] * mw_avg * -4.3109506105982735e-02 * rho_inv);
  jac[315] -= (h[5] * (working_temp * jac[321] - (j_temp * (cp[14] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[342] += (spec_rates[5] * mw_avg * -6.2595983243998982e-02 * rho_inv);
  jac[336] -= (h[5] * (working_temp * jac[342] - (j_temp * (cp[15] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[363] += (spec_rates[5] * mw_avg * -9.2336272421544201e-04 * rho_inv);
  jac[357] -= (h[5] * (working_temp * jac[363] - (j_temp * (cp[16] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[384] += (spec_rates[5] * mw_avg * -2.3195587676175893e-02 * rho_inv);
  jac[378] -= (h[5] * (working_temp * jac[384] - (j_temp * (cp[17] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[405] += (spec_rates[5] * mw_avg * -4.3974674272101555e-02 * rho_inv);
  jac[399] -= (h[5] * (working_temp * jac[405] - (j_temp * (cp[18] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[426] += (spec_rates[5] * mw_avg * -1.9212499494008703e-01 * rho_inv);
  jac[420] -= (h[5] * (working_temp * jac[426] - (j_temp * (cp[19] - cp[20]) * spec_rates[5] * 1.80152800e+01)));
  jac[28] += (spec_rates[6] * mw_avg * 1.5195120576006721e+01 * rho_inv);
  jac[21] -= (h[6] * (working_temp * jac[28] - (j_temp * (cp[0] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[49] += (spec_rates[6] * mw_avg * 3.1568486054110576e+01 * rho_inv);
  jac[42] -= (h[6] * (working_temp * jac[49] - (j_temp * (cp[1] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[70] += (spec_rates[6] * mw_avg * 8.8475371035083372e-01 * rho_inv);
  jac[63] -= (h[6] * (working_temp * jac[70] - (j_temp * (cp[2] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[91] += (spec_rates[6] * mw_avg * -1.4674559587314970e-01 * rho_inv);
  jac[84] -= (h[6] * (working_temp * jac[91] - (j_temp * (cp[3] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[112] += (spec_rates[6] * mw_avg * 7.6249009820273750e-01 * rho_inv);
  jac[105] -= (h[6] * (working_temp * jac[112] - (j_temp * (cp[4] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[133] += (spec_rates[6] * mw_avg * 6.5390758179431885e-01 * rho_inv);
  jac[126] -= (h[6] * (working_temp * jac[133] - (j_temp * (cp[5] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[154] += (spec_rates[6] * mw_avg * -1.7824490209713328e-01 * rho_inv);
  jac[147] -= (h[6] * (working_temp * jac[154] - (j_temp * (cp[6] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[175] += (spec_rates[6] * mw_avg * 1.1748614194797251e+00 * rho_inv);
  jac[168] -= (h[6] * (working_temp * jac[175] - (j_temp * (cp[7] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[196] += (spec_rates[6] * mw_avg * 1.1748614194797251e+00 * rho_inv);
  jac[189] -= (h[6] * (working_temp * jac[196] - (j_temp * (cp[8] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[217] += (spec_rates[6] * mw_avg * 1.0171082847052364e+00 * rho_inv);
  jac[210] -= (h[6] * (working_temp * jac[217] - (j_temp * (cp[9] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[238] += (spec_rates[6] * mw_avg * 8.7917788550300524e-01 * rho_inv);
  jac[231] -= (h[6] * (working_temp * jac[238] - (j_temp * (cp[10] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[259] += (spec_rates[6] * mw_avg * 1.2955881738440931e-04 * rho_inv);
  jac[252] -= (h[6] * (working_temp * jac[259] - (j_temp * (cp[11] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[280] += (spec_rates[6] * mw_avg * -4.2825876264637441e-01 * rho_inv);
  jac[273] -= (h[6] * (working_temp * jac[280] - (j_temp * (cp[12] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[301] += (spec_rates[6] * mw_avg * -4.0800789167172183e-02 * rho_inv);
  jac[294] -= (h[6] * (working_temp * jac[301] - (j_temp * (cp[13] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[322] += (spec_rates[6] * mw_avg * -7.8983188691409995e-02 * rho_inv);
  jac[315] -= (h[6] * (working_temp * jac[322] - (j_temp * (cp[14] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[343] += (spec_rates[6] * mw_avg * -1.1468538618212047e-01 * rho_inv);
  jac[336] -= (h[6] * (working_temp * jac[343] - (j_temp * (cp[15] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[364] += (spec_rates[6] * mw_avg * -1.6917413087040999e-03 * rho_inv);
  jac[357] -= (h[6] * (working_temp * jac[364] - (j_temp * (cp[16] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[385] += (spec_rates[6] * mw_avg * -4.2497853576227623e-02 * rho_inv);
  jac[378] -= (h[6] * (working_temp * jac[385] - (j_temp * (cp[17] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[406] += (spec_rates[6] * mw_avg * -8.0568308695948401e-02 * rho_inv);
  jac[399] -= (h[6] * (working_temp * jac[406] - (j_temp * (cp[18] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[427] += (spec_rates[6] * mw_avg * -3.5200228669711314e-01 * rho_inv);
  jac[420] -= (h[6] * (working_temp * jac[427] - (j_temp * (cp[19] - cp[20]) * spec_rates[6] * 3.30067400e+01)));
  jac[29] += (spec_rates[7] * mw_avg * 6.4574730162741654e+00 * rho_inv);
  jac[21] -= (h[7] * (working_temp * jac[29] - (j_temp * (cp[0] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[50] += (spec_rates[7] * mw_avg * 1.3415664972144553e+01 * rho_inv);
  jac[42] -= (h[7] * (working_temp * jac[50] - (j_temp * (cp[1] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[71] += (spec_rates[7] * mw_avg * 3.7599393713665458e-01 * rho_inv);
  jac[63] -= (h[7] * (working_temp * jac[71] - (j_temp * (cp[2] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[92] += (spec_rates[7] * mw_avg * -6.2362501229784151e-02 * rho_inv);
  jac[84] -= (h[7] * (working_temp * jac[92] - (j_temp * (cp[3] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[113] += (spec_rates[7] * mw_avg * 3.2403554875998097e-01 * rho_inv);
  jac[105] -= (h[7] * (working_temp * jac[113] - (j_temp * (cp[4] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[134] += (spec_rates[7] * mw_avg * 2.7789121800332584e-01 * rho_inv);
  jac[126] -= (h[7] * (working_temp * jac[134] - (j_temp * (cp[5] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[155] += (spec_rates[7] * mw_avg * -7.5748766837568218e-02 * rho_inv);
  jac[147] -= (h[7] * (working_temp * jac[155] - (j_temp * (cp[6] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[176] += (spec_rates[7] * mw_avg * 4.9928106040377707e-01 * rho_inv);
  jac[168] -= (h[7] * (working_temp * jac[176] - (j_temp * (cp[7] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[197] += (spec_rates[7] * mw_avg * 4.9928106040377707e-01 * rho_inv);
  jac[189] -= (h[7] * (working_temp * jac[197] - (j_temp * (cp[8] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[218] += (spec_rates[7] * mw_avg * 4.3224068346544325e-01 * rho_inv);
  jac[210] -= (h[7] * (working_temp * jac[218] - (j_temp * (cp[9] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[239] += (spec_rates[7] * mw_avg * 3.7362437788780090e-01 * rho_inv);
  jac[231] -= (h[7] * (working_temp * jac[239] - (j_temp * (cp[10] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[260] += (spec_rates[7] * mw_avg * 5.5058633006259423e-05 * rho_inv);
  jac[252] -= (h[7] * (working_temp * jac[260] - (j_temp * (cp[11] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[281] += (spec_rates[7] * mw_avg * -1.8199720034723743e-01 * rho_inv);
  jac[273] -= (h[7] * (working_temp * jac[281] - (j_temp * (cp[12] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[302] += (spec_rates[7] * mw_avg * -1.7339118421062609e-02 * rho_inv);
  jac[294] -= (h[7] * (working_temp * jac[302] - (j_temp * (cp[13] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[323] += (spec_rates[7] * mw_avg * -3.3565499343217925e-02 * rho_inv);
  jac[315] -= (h[7] * (working_temp * jac[323] - (j_temp * (cp[14] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[344] += (spec_rates[7] * mw_avg * -4.8737868378708762e-02 * rho_inv);
  jac[336] -= (h[7] * (working_temp * jac[344] - (j_temp * (cp[15] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[365] += (spec_rates[7] * mw_avg * -7.1893959622293391e-04 * rho_inv);
  jac[357] -= (h[7] * (working_temp * jac[365] - (j_temp * (cp[16] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[386] += (spec_rates[7] * mw_avg * -1.8060320176161465e-02 * rho_inv);
  jac[378] -= (h[7] * (working_temp * jac[386] - (j_temp * (cp[17] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[407] += (spec_rates[7] * mw_avg * -3.4239128065389812e-02 * rho_inv);
  jac[399] -= (h[7] * (working_temp * jac[407] - (j_temp * (cp[18] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[428] += (spec_rates[7] * mw_avg * -1.4959047258911368e-01 * rho_inv);
  jac[420] -= (h[7] * (working_temp * jac[428] - (j_temp * (cp[19] - cp[20]) * spec_rates[7] * 1.40268800e+01)));
  jac[30] += (spec_rates[8] * mw_avg * 6.4574730162741654e+00 * rho_inv);
  jac[21] -= (h[8] * (working_temp * jac[30] - (j_temp * (cp[0] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[51] += (spec_rates[8] * mw_avg * 1.3415664972144553e+01 * rho_inv);
  jac[42] -= (h[8] * (working_temp * jac[51] - (j_temp * (cp[1] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[72] += (spec_rates[8] * mw_avg * 3.7599393713665458e-01 * rho_inv);
  jac[63] -= (h[8] * (working_temp * jac[72] - (j_temp * (cp[2] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[93] += (spec_rates[8] * mw_avg * -6.2362501229784151e-02 * rho_inv);
  jac[84] -= (h[8] * (working_temp * jac[93] - (j_temp * (cp[3] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[114] += (spec_rates[8] * mw_avg * 3.2403554875998097e-01 * rho_inv);
  jac[105] -= (h[8] * (working_temp * jac[114] - (j_temp * (cp[4] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[135] += (spec_rates[8] * mw_avg * 2.7789121800332584e-01 * rho_inv);
  jac[126] -= (h[8] * (working_temp * jac[135] - (j_temp * (cp[5] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[156] += (spec_rates[8] * mw_avg * -7.5748766837568218e-02 * rho_inv);
  jac[147] -= (h[8] * (working_temp * jac[156] - (j_temp * (cp[6] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[177] += (spec_rates[8] * mw_avg * 4.9928106040377707e-01 * rho_inv);
  jac[168] -= (h[8] * (working_temp * jac[177] - (j_temp * (cp[7] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[198] += (spec_rates[8] * mw_avg * 4.9928106040377707e-01 * rho_inv);
  jac[189] -= (h[8] * (working_temp * jac[198] - (j_temp * (cp[8] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[219] += (spec_rates[8] * mw_avg * 4.3224068346544325e-01 * rho_inv);
  jac[210] -= (h[8] * (working_temp * jac[219] - (j_temp * (cp[9] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[240] += (spec_rates[8] * mw_avg * 3.7362437788780090e-01 * rho_inv);
  jac[231] -= (h[8] * (working_temp * jac[240] - (j_temp * (cp[10] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[261] += (spec_rates[8] * mw_avg * 5.5058633006259423e-05 * rho_inv);
  jac[252] -= (h[8] * (working_temp * jac[261] - (j_temp * (cp[11] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[282] += (spec_rates[8] * mw_avg * -1.8199720034723743e-01 * rho_inv);
  jac[273] -= (h[8] * (working_temp * jac[282] - (j_temp * (cp[12] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[303] += (spec_rates[8] * mw_avg * -1.7339118421062609e-02 * rho_inv);
  jac[294] -= (h[8] * (working_temp * jac[303] - (j_temp * (cp[13] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[324] += (spec_rates[8] * mw_avg * -3.3565499343217925e-02 * rho_inv);
  jac[315] -= (h[8] * (working_temp * jac[324] - (j_temp * (cp[14] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[345] += (spec_rates[8] * mw_avg * -4.8737868378708762e-02 * rho_inv);
  jac[336] -= (h[8] * (working_temp * jac[345] - (j_temp * (cp[15] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[366] += (spec_rates[8] * mw_avg * -7.1893959622293391e-04 * rho_inv);
  jac[357] -= (h[8] * (working_temp * jac[366] - (j_temp * (cp[16] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[387] += (spec_rates[8] * mw_avg * -1.8060320176161465e-02 * rho_inv);
  jac[378] -= (h[8] * (working_temp * jac[387] - (j_temp * (cp[17] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[408] += (spec_rates[8] * mw_avg * -3.4239128065389812e-02 * rho_inv);
  jac[399] -= (h[8] * (working_temp * jac[408] - (j_temp * (cp[18] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[429] += (spec_rates[8] * mw_avg * -1.4959047258911368e-01 * rho_inv);
  jac[420] -= (h[8] * (working_temp * jac[429] - (j_temp * (cp[19] - cp[20]) * spec_rates[8] * 1.40268800e+01)));
  jac[31] += (spec_rates[9] * mw_avg * 6.9214924811889142e+00 * rho_inv);
  jac[21] -= (h[9] * (working_temp * jac[31] - (j_temp * (cp[0] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[52] += (spec_rates[9] * mw_avg * 1.4379684437059302e+01 * rho_inv);
  jac[42] -= (h[9] * (working_temp * jac[52] - (j_temp * (cp[1] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[73] += (spec_rates[9] * mw_avg * 4.0301201449936958e-01 * rho_inv);
  jac[63] -= (h[9] * (working_temp * jac[73] - (j_temp * (cp[2] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[94] += (spec_rates[9] * mw_avg * -6.6843730091052558e-02 * rho_inv);
  jac[84] -= (h[9] * (working_temp * jac[94] - (j_temp * (cp[3] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[115] += (spec_rates[9] * mw_avg * 3.4732001337485863e-01 * rho_inv);
  jac[105] -= (h[9] * (working_temp * jac[115] - (j_temp * (cp[4] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[136] += (spec_rates[9] * mw_avg * 2.9785985495425665e-01 * rho_inv);
  jac[126] -= (h[9] * (working_temp * jac[136] - (j_temp * (cp[5] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[157] += (spec_rates[9] * mw_avg * -8.1191902591653139e-02 * rho_inv);
  jac[147] -= (h[9] * (working_temp * jac[157] - (j_temp * (cp[6] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[178] += (spec_rates[9] * mw_avg * 5.3515827272921102e-01 * rho_inv);
  jac[168] -= (h[9] * (working_temp * jac[178] - (j_temp * (cp[7] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[199] += (spec_rates[9] * mw_avg * 5.3515827272921102e-01 * rho_inv);
  jac[189] -= (h[9] * (working_temp * jac[199] - (j_temp * (cp[8] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[220] += (spec_rates[9] * mw_avg * 4.6330052531852528e-01 * rho_inv);
  jac[210] -= (h[9] * (working_temp * jac[220] - (j_temp * (cp[9] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[241] += (spec_rates[9] * mw_avg * 4.0047218406053714e-01 * rho_inv);
  jac[231] -= (h[9] * (working_temp * jac[241] - (j_temp * (cp[10] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[262] += (spec_rates[9] * mw_avg * 5.9015022349600859e-05 * rho_inv);
  jac[252] -= (h[9] * (working_temp * jac[262] - (j_temp * (cp[11] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[283] += (spec_rates[9] * mw_avg * -1.9507510919924120e-01 * rho_inv);
  jac[273] -= (h[9] * (working_temp * jac[283] - (j_temp * (cp[12] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[304] += (spec_rates[9] * mw_avg * -1.8585068412887297e-02 * rho_inv);
  jac[294] -= (h[9] * (working_temp * jac[304] - (j_temp * (cp[13] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[325] += (spec_rates[9] * mw_avg * -3.5977440516736424e-02 * rho_inv);
  jac[315] -= (h[9] * (working_temp * jac[325] - (j_temp * (cp[14] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[346] += (spec_rates[9] * mw_avg * -5.2240061814001273e-02 * rho_inv);
  jac[336] -= (h[9] * (working_temp * jac[346] - (j_temp * (cp[15] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[367] += (spec_rates[9] * mw_avg * -7.7060097613186195e-04 * rho_inv);
  jac[357] -= (h[9] * (working_temp * jac[367] - (j_temp * (cp[16] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[388] += (spec_rates[9] * mw_avg * -1.9358094101536192e-02 * rho_inv);
  jac[378] -= (h[9] * (working_temp * jac[388] - (j_temp * (cp[17] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[409] += (spec_rates[9] * mw_avg * -3.6699474681474720e-02 * rho_inv);
  jac[399] -= (h[9] * (working_temp * jac[409] - (j_temp * (cp[18] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[430] += (spec_rates[9] * mw_avg * -1.6033970698346731e-01 * rho_inv);
  jac[420] -= (h[9] * (working_temp * jac[430] - (j_temp * (cp[19] - cp[20]) * spec_rates[9] * 1.50348200e+01)));
  jac[32] += (spec_rates[10] * mw_avg * 7.3855119461036631e+00 * rho_inv);
  jac[21] -= (h[10] * (working_temp * jac[32] - (j_temp * (cp[0] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[53] += (spec_rates[10] * mw_avg * 1.5343703901974052e+01 * rho_inv);
  jac[42] -= (h[10] * (working_temp * jac[53] - (j_temp * (cp[1] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[74] += (spec_rates[10] * mw_avg * 4.3003009186208457e-01 * rho_inv);
  jac[63] -= (h[10] * (working_temp * jac[74] - (j_temp * (cp[2] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[95] += (spec_rates[10] * mw_avg * -7.1324958952320980e-02 * rho_inv);
  jac[84] -= (h[10] * (working_temp * jac[95] - (j_temp * (cp[3] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[116] += (spec_rates[10] * mw_avg * 3.7060447798973634e-01 * rho_inv);
  jac[105] -= (h[10] * (working_temp * jac[116] - (j_temp * (cp[4] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[137] += (spec_rates[10] * mw_avg * 3.1782849190518753e-01 * rho_inv);
  jac[126] -= (h[10] * (working_temp * jac[137] - (j_temp * (cp[5] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[158] += (spec_rates[10] * mw_avg * -8.6635038345738047e-02 * rho_inv);
  jac[147] -= (h[10] * (working_temp * jac[158] - (j_temp * (cp[6] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[179] += (spec_rates[10] * mw_avg * 5.7103548505464508e-01 * rho_inv);
  jac[168] -= (h[10] * (working_temp * jac[179] - (j_temp * (cp[7] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[200] += (spec_rates[10] * mw_avg * 5.7103548505464508e-01 * rho_inv);
  jac[189] -= (h[10] * (working_temp * jac[200] - (j_temp * (cp[8] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[221] += (spec_rates[10] * mw_avg * 4.9436036717160731e-01 * rho_inv);
  jac[210] -= (h[10] * (working_temp * jac[221] - (j_temp * (cp[9] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[242] += (spec_rates[10] * mw_avg * 4.2731999023327338e-01 * rho_inv);
  jac[231] -= (h[10] * (working_temp * jac[242] - (j_temp * (cp[10] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[263] += (spec_rates[10] * mw_avg * 6.2971411692942314e-05 * rho_inv);
  jac[252] -= (h[10] * (working_temp * jac[263] - (j_temp * (cp[11] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[284] += (spec_rates[10] * mw_avg * -2.0815301805124498e-01 * rho_inv);
  jac[273] -= (h[10] * (working_temp * jac[284] - (j_temp * (cp[12] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[305] += (spec_rates[10] * mw_avg * -1.9831018404711988e-02 * rho_inv);
  jac[294] -= (h[10] * (working_temp * jac[305] - (j_temp * (cp[13] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[326] += (spec_rates[10] * mw_avg * -3.8389381690254923e-02 * rho_inv);
  jac[315] -= (h[10] * (working_temp * jac[326] - (j_temp * (cp[14] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[347] += (spec_rates[10] * mw_avg * -5.5742255249293778e-02 * rho_inv);
  jac[336] -= (h[10] * (working_temp * jac[347] - (j_temp * (cp[15] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[368] += (spec_rates[10] * mw_avg * -8.2226235604078999e-04 * rho_inv);
  jac[357] -= (h[10] * (working_temp * jac[368] - (j_temp * (cp[16] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[389] += (spec_rates[10] * mw_avg * -2.0655868026910915e-02 * rho_inv);
  jac[378] -= (h[10] * (working_temp * jac[389] - (j_temp * (cp[17] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[410] += (spec_rates[10] * mw_avg * -3.9159821297559627e-02 * rho_inv);
  jac[399] -= (h[10] * (working_temp * jac[410] - (j_temp * (cp[18] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[431] += (spec_rates[10] * mw_avg * -1.7108894137782099e-01 * rho_inv);
  jac[420] -= (h[10] * (working_temp * jac[431] - (j_temp * (cp[19] - cp[20]) * spec_rates[10] * 1.60427600e+01)));
  jac[33] += (spec_rates[11] * mw_avg * 1.2894984641990655e+01 * rho_inv);
  jac[21] -= (h[11] * (working_temp * jac[33] - (j_temp * (cp[0] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[54] += (spec_rates[11] * mw_avg * 2.6789859336912972e+01 * rho_inv);
  jac[42] -= (h[11] * (working_temp * jac[54] - (j_temp * (cp[1] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[75] += (spec_rates[11] * mw_avg * 7.5082559890528389e-01 * rho_inv);
  jac[63] -= (h[11] * (working_temp * jac[75] - (j_temp * (cp[2] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[96] += (spec_rates[11] * mw_avg * -1.2453222701318796e-01 * rho_inv);
  jac[84] -= (h[11] * (working_temp * jac[96] - (j_temp * (cp[3] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[117] += (spec_rates[11] * mw_avg * 6.4706943632415548e-01 * rho_inv);
  jac[105] -= (h[11] * (working_temp * jac[117] - (j_temp * (cp[4] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[138] += (spec_rates[11] * mw_avg * 5.5492341652315824e-01 * rho_inv);
  jac[126] -= (h[11] * (working_temp * jac[138] - (j_temp * (cp[5] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[159] += (spec_rates[11] * mw_avg * -1.5126337850092259e-01 * rho_inv);
  jac[147] -= (h[11] * (working_temp * jac[159] - (j_temp * (cp[6] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[180] += (spec_rates[11] * mw_avg * 9.9701873933005458e-01 * rho_inv);
  jac[168] -= (h[11] * (working_temp * jac[180] - (j_temp * (cp[7] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[201] += (spec_rates[11] * mw_avg * 9.9701873933005458e-01 * rho_inv);
  jac[189] -= (h[11] * (working_temp * jac[201] - (j_temp * (cp[8] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[222] += (spec_rates[11] * mw_avg * 8.6314522118535630e-01 * rho_inv);
  jac[210] -= (h[11] * (working_temp * jac[222] - (j_temp * (cp[9] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[243] += (spec_rates[11] * mw_avg * 7.4609380520746305e-01 * rho_inv);
  jac[231] -= (h[11] * (working_temp * jac[243] - (j_temp * (cp[10] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[264] += (spec_rates[11] * mw_avg * 1.0994706834011048e-04 * rho_inv);
  jac[252] -= (h[11] * (working_temp * jac[264] - (j_temp * (cp[11] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[285] += (spec_rates[11] * mw_avg * -3.6343180954041521e-01 * rho_inv);
  jac[273] -= (h[11] * (working_temp * jac[285] - (j_temp * (cp[12] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[306] += (spec_rates[11] * mw_avg * -3.4624638025086987e-02 * rho_inv);
  jac[294] -= (h[11] * (working_temp * jac[306] - (j_temp * (cp[13] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[327] += (spec_rates[11] * mw_avg * -6.7027240755126685e-02 * rho_inv);
  jac[315] -= (h[11] * (working_temp * jac[327] - (j_temp * (cp[14] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[348] += (spec_rates[11] * mw_avg * -9.7325077881537728e-02 * rho_inv);
  jac[336] -= (h[11] * (working_temp * jac[348] - (j_temp * (cp[15] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[369] += (spec_rates[11] * mw_avg * -1.4356568008026638e-03 * rho_inv);
  jac[357] -= (h[11] * (working_temp * jac[369] - (j_temp * (cp[16] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[390] += (spec_rates[11] * mw_avg * -3.6064812150838468e-02 * rho_inv);
  jac[378] -= (h[11] * (working_temp * jac[390] - (j_temp * (cp[17] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[411] += (spec_rates[11] * mw_avg * -6.8372415873151751e-02 * rho_inv);
  jac[399] -= (h[11] * (working_temp * jac[411] - (j_temp * (cp[18] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[432] += (spec_rates[11] * mw_avg * -2.9871852995178610e-01 * rho_inv);
  jac[420] -= (h[11] * (working_temp * jac[432] - (j_temp * (cp[19] - cp[20]) * spec_rates[11] * 2.80104000e+01)));
  jac[34] += (spec_rates[12] * mw_avg * 2.0260535197536644e+01 * rho_inv);
  jac[21] -= (h[12] * (working_temp * jac[34] - (j_temp * (cp[0] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[55] += (spec_rates[12] * mw_avg * 4.2092092631510887e+01 * rho_inv);
  jac[42] -= (h[12] * (working_temp * jac[55] - (j_temp * (cp[1] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[76] += (spec_rates[12] * mw_avg * 1.1796934153993435e+00 * rho_inv);
  jac[63] -= (h[12] * (working_temp * jac[76] - (j_temp * (cp[2] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[97] += (spec_rates[12] * mw_avg * -1.9566441051912861e-01 * rho_inv);
  jac[84] -= (h[12] * (working_temp * jac[97] - (j_temp * (cp[3] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[118] += (spec_rates[12] * mw_avg * 1.0166722531180856e+00 * rho_inv);
  jac[105] -= (h[12] * (working_temp * jac[118] - (j_temp * (cp[4] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[139] += (spec_rates[12] * mw_avg * 8.7189288894485240e-01 * rho_inv);
  jac[126] -= (h[12] * (working_temp * jac[139] - (j_temp * (cp[5] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[160] += (spec_rates[12] * mw_avg * -2.3766426167244681e-01 * rho_inv);
  jac[147] -= (h[12] * (working_temp * jac[160] - (j_temp * (cp[6] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[181] += (spec_rates[12] * mw_avg * 1.5665108429072001e+00 * rho_inv);
  jac[168] -= (h[12] * (working_temp * jac[181] - (j_temp * (cp[7] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[202] += (spec_rates[12] * mw_avg * 1.5665108429072001e+00 * rho_inv);
  jac[189] -= (h[12] * (working_temp * jac[202] - (j_temp * (cp[8] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[223] += (spec_rates[12] * mw_avg * 1.3561694426114335e+00 * rho_inv);
  jac[210] -= (h[12] * (working_temp * jac[223] - (j_temp * (cp[9] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[244] += (spec_rates[12] * mw_avg * 1.1722588448725975e+00 * rho_inv);
  jac[231] -= (h[12] * (working_temp * jac[244] - (j_temp * (cp[10] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[265] += (spec_rates[12] * mw_avg * 1.7274828236064443e-04 * rho_inv);
  jac[252] -= (h[12] * (working_temp * jac[265] - (j_temp * (cp[11] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[286] += (spec_rates[12] * mw_avg * -5.7102223643760053e-01 * rho_inv);
  jac[273] -= (h[12] * (working_temp * jac[286] - (j_temp * (cp[12] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[307] += (spec_rates[12] * mw_avg * -5.4402057612760735e-02 * rho_inv);
  jac[294] -= (h[12] * (working_temp * jac[307] - (j_temp * (cp[13] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[328] += (spec_rates[12] * mw_avg * -1.0531286451407244e-01 * rho_inv);
  jac[315] -= (h[12] * (working_temp * jac[328] - (j_temp * (cp[14] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[349] += (spec_rates[12] * mw_avg * -1.5291667425495173e-01 * rho_inv);
  jac[336] -= (h[12] * (working_temp * jac[349] - (j_temp * (cp[15] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[370] += (spec_rates[12] * mw_avg * -2.2556967652002497e-03 * rho_inv);
  jac[357] -= (h[12] * (working_temp * jac[370] - (j_temp * (cp[16] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[391] += (spec_rates[12] * mw_avg * -5.6664851976264925e-02 * rho_inv);
  jac[378] -= (h[12] * (working_temp * jac[391] - (j_temp * (cp[17] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[412] += (spec_rates[12] * mw_avg * -1.0742639691308349e-01 * rho_inv);
  jac[399] -= (h[12] * (working_temp * jac[412] - (j_temp * (cp[18] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[433] += (spec_rates[12] * mw_avg * -4.6934505610316585e-01 * rho_inv);
  jac[420] -= (h[12] * (working_temp * jac[433] - (j_temp * (cp[19] - cp[20]) * spec_rates[12] * 4.40098000e+01)));
  jac[35] += (spec_rates[13] * mw_avg * 1.3359004106905404e+01 * rho_inv);
  jac[21] -= (h[13] * (working_temp * jac[35] - (j_temp * (cp[0] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[56] += (spec_rates[13] * mw_avg * 2.7753878801827717e+01 * rho_inv);
  jac[42] -= (h[13] * (working_temp * jac[56] - (j_temp * (cp[1] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[77] += (spec_rates[13] * mw_avg * 7.7784367626799900e-01 * rho_inv);
  jac[63] -= (h[13] * (working_temp * jac[77] - (j_temp * (cp[2] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[98] += (spec_rates[13] * mw_avg * -1.2901345587445640e-01 * rho_inv);
  jac[84] -= (h[13] * (working_temp * jac[98] - (j_temp * (cp[3] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[119] += (spec_rates[13] * mw_avg * 6.7035390093903313e-01 * rho_inv);
  jac[105] -= (h[13] * (working_temp * jac[119] - (j_temp * (cp[4] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[140] += (spec_rates[13] * mw_avg * 5.7489205347408912e-01 * rho_inv);
  jac[126] -= (h[13] * (working_temp * jac[140] - (j_temp * (cp[5] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[161] += (spec_rates[13] * mw_avg * -1.5670651425500751e-01 * rho_inv);
  jac[147] -= (h[13] * (working_temp * jac[161] - (j_temp * (cp[6] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[182] += (spec_rates[13] * mw_avg * 1.0328959516554888e+00 * rho_inv);
  jac[168] -= (h[13] * (working_temp * jac[182] - (j_temp * (cp[7] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[203] += (spec_rates[13] * mw_avg * 1.0328959516554888e+00 * rho_inv);
  jac[189] -= (h[13] * (working_temp * jac[203] - (j_temp * (cp[8] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[224] += (spec_rates[13] * mw_avg * 8.9420506303843839e-01 * rho_inv);
  jac[210] -= (h[13] * (working_temp * jac[224] - (j_temp * (cp[9] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[245] += (spec_rates[13] * mw_avg * 7.7294161138019923e-01 * rho_inv);
  jac[231] -= (h[13] * (working_temp * jac[245] - (j_temp * (cp[10] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[266] += (spec_rates[13] * mw_avg * 1.1390345768345193e-04 * rho_inv);
  jac[252] -= (h[13] * (working_temp * jac[266] - (j_temp * (cp[11] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[287] += (spec_rates[13] * mw_avg * -3.7650971839241898e-01 * rho_inv);
  jac[273] -= (h[13] * (working_temp * jac[287] - (j_temp * (cp[12] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[308] += (spec_rates[13] * mw_avg * -3.5870588016911675e-02 * rho_inv);
  jac[294] -= (h[13] * (working_temp * jac[308] - (j_temp * (cp[13] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[329] += (spec_rates[13] * mw_avg * -6.9439181928645191e-02 * rho_inv);
  jac[315] -= (h[13] * (working_temp * jac[329] - (j_temp * (cp[14] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[350] += (spec_rates[13] * mw_avg * -1.0082727131683024e-01 * rho_inv);
  jac[336] -= (h[13] * (working_temp * jac[350] - (j_temp * (cp[15] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[371] += (spec_rates[13] * mw_avg * -1.4873181807115918e-03 * rho_inv);
  jac[357] -= (h[13] * (working_temp * jac[371] - (j_temp * (cp[16] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[392] += (spec_rates[13] * mw_avg * -3.7362586076213192e-02 * rho_inv);
  jac[378] -= (h[13] * (working_temp * jac[392] - (j_temp * (cp[17] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[413] += (spec_rates[13] * mw_avg * -7.0832762489236659e-02 * rho_inv);
  jac[399] -= (h[13] * (working_temp * jac[413] - (j_temp * (cp[18] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[434] += (spec_rates[13] * mw_avg * -3.0946776434613976e-01 * rho_inv);
  jac[420] -= (h[13] * (working_temp * jac[434] - (j_temp * (cp[19] - cp[20]) * spec_rates[13] * 2.90183400e+01)));
  jac[36] += (spec_rates[14] * mw_avg * 1.3823023571820153e+01 * rho_inv);
  jac[21] -= (h[14] * (working_temp * jac[36] - (j_temp * (cp[0] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[57] += (spec_rates[14] * mw_avg * 2.8717898266742470e+01 * rho_inv);
  jac[42] -= (h[14] * (working_temp * jac[57] - (j_temp * (cp[1] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[78] += (spec_rates[14] * mw_avg * 8.0486175363071399e-01 * rho_inv);
  jac[63] -= (h[14] * (working_temp * jac[78] - (j_temp * (cp[2] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[99] += (spec_rates[14] * mw_avg * -1.3349468473572479e-01 * rho_inv);
  jac[84] -= (h[14] * (working_temp * jac[99] - (j_temp * (cp[3] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[120] += (spec_rates[14] * mw_avg * 6.9363836555391090e-01 * rho_inv);
  jac[105] -= (h[14] * (working_temp * jac[120] - (j_temp * (cp[4] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[141] += (spec_rates[14] * mw_avg * 5.9486069042501988e-01 * rho_inv);
  jac[126] -= (h[14] * (working_temp * jac[141] - (j_temp * (cp[5] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[162] += (spec_rates[14] * mw_avg * -1.6214965000909243e-01 * rho_inv);
  jac[147] -= (h[14] * (working_temp * jac[162] - (j_temp * (cp[6] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[183] += (spec_rates[14] * mw_avg * 1.0687731639809228e+00 * rho_inv);
  jac[168] -= (h[14] * (working_temp * jac[183] - (j_temp * (cp[7] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[204] += (spec_rates[14] * mw_avg * 1.0687731639809228e+00 * rho_inv);
  jac[189] -= (h[14] * (working_temp * jac[204] - (j_temp * (cp[8] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[225] += (spec_rates[14] * mw_avg * 9.2526490489152036e-01 * rho_inv);
  jac[210] -= (h[14] * (working_temp * jac[225] - (j_temp * (cp[9] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[246] += (spec_rates[14] * mw_avg * 7.9978941755293542e-01 * rho_inv);
  jac[231] -= (h[14] * (working_temp * jac[246] - (j_temp * (cp[10] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[267] += (spec_rates[14] * mw_avg * 1.1785984702679335e-04 * rho_inv);
  jac[252] -= (h[14] * (working_temp * jac[267] - (j_temp * (cp[11] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[288] += (spec_rates[14] * mw_avg * -3.8958762724442275e-01 * rho_inv);
  jac[273] -= (h[14] * (working_temp * jac[288] - (j_temp * (cp[12] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[309] += (spec_rates[14] * mw_avg * -3.7116538008736356e-02 * rho_inv);
  jac[294] -= (h[14] * (working_temp * jac[309] - (j_temp * (cp[13] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[330] += (spec_rates[14] * mw_avg * -7.1851123102163683e-02 * rho_inv);
  jac[315] -= (h[14] * (working_temp * jac[330] - (j_temp * (cp[14] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[351] += (spec_rates[14] * mw_avg * -1.0432946475212275e-01 * rho_inv);
  jac[336] -= (h[14] * (working_temp * jac[351] - (j_temp * (cp[15] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[372] += (spec_rates[14] * mw_avg * -1.5389795606205201e-03 * rho_inv);
  jac[357] -= (h[14] * (working_temp * jac[372] - (j_temp * (cp[16] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[393] += (spec_rates[14] * mw_avg * -3.8660360001587915e-02 * rho_inv);
  jac[378] -= (h[14] * (working_temp * jac[393] - (j_temp * (cp[17] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[414] += (spec_rates[14] * mw_avg * -7.3293109105321566e-02 * rho_inv);
  jac[399] -= (h[14] * (working_temp * jac[414] - (j_temp * (cp[18] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[435] += (spec_rates[14] * mw_avg * -3.2021699874049342e-01 * rho_inv);
  jac[420] -= (h[14] * (working_temp * jac[435] - (j_temp * (cp[19] - cp[20]) * spec_rates[14] * 3.00262800e+01)));
  jac[37] += (spec_rates[15] * mw_avg * 1.4287043036734900e+01 * rho_inv);
  jac[21] -= (h[15] * (working_temp * jac[37] - (j_temp * (cp[0] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[58] += (spec_rates[15] * mw_avg * 2.9681917731657215e+01 * rho_inv);
  jac[42] -= (h[15] * (working_temp * jac[58] - (j_temp * (cp[1] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[79] += (spec_rates[15] * mw_avg * 8.3187983099342888e-01 * rho_inv);
  jac[63] -= (h[15] * (working_temp * jac[79] - (j_temp * (cp[2] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[100] += (spec_rates[15] * mw_avg * -1.3797591359699321e-01 * rho_inv);
  jac[84] -= (h[15] * (working_temp * jac[100] - (j_temp * (cp[3] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[121] += (spec_rates[15] * mw_avg * 7.1692283016878855e-01 * rho_inv);
  jac[105] -= (h[15] * (working_temp * jac[121] - (j_temp * (cp[4] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[142] += (spec_rates[15] * mw_avg * 6.1482932737595075e-01 * rho_inv);
  jac[126] -= (h[15] * (working_temp * jac[142] - (j_temp * (cp[5] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[163] += (spec_rates[15] * mw_avg * -1.6759278576317732e-01 * rho_inv);
  jac[147] -= (h[15] * (working_temp * jac[163] - (j_temp * (cp[6] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[184] += (spec_rates[15] * mw_avg * 1.1046503763063564e+00 * rho_inv);
  jac[168] -= (h[15] * (working_temp * jac[184] - (j_temp * (cp[7] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[205] += (spec_rates[15] * mw_avg * 1.1046503763063564e+00 * rho_inv);
  jac[189] -= (h[15] * (working_temp * jac[205] - (j_temp * (cp[8] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[226] += (spec_rates[15] * mw_avg * 9.5632474674460244e-01 * rho_inv);
  jac[210] -= (h[15] * (working_temp * jac[226] - (j_temp * (cp[9] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[247] += (spec_rates[15] * mw_avg * 8.2663722372567161e-01 * rho_inv);
  jac[231] -= (h[15] * (working_temp * jac[247] - (j_temp * (cp[10] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[268] += (spec_rates[15] * mw_avg * 1.2181623637013480e-04 * rho_inv);
  jac[252] -= (h[15] * (working_temp * jac[268] - (j_temp * (cp[11] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[289] += (spec_rates[15] * mw_avg * -4.0266553609642652e-01 * rho_inv);
  jac[273] -= (h[15] * (working_temp * jac[289] - (j_temp * (cp[12] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[310] += (spec_rates[15] * mw_avg * -3.8362488000561044e-02 * rho_inv);
  jac[294] -= (h[15] * (working_temp * jac[310] - (j_temp * (cp[13] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[331] += (spec_rates[15] * mw_avg * -7.4263064275682161e-02 * rho_inv);
  jac[315] -= (h[15] * (working_temp * jac[331] - (j_temp * (cp[14] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[352] += (spec_rates[15] * mw_avg * -1.0783165818741525e-01 * rho_inv);
  jac[336] -= (h[15] * (working_temp * jac[352] - (j_temp * (cp[15] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[373] += (spec_rates[15] * mw_avg * -1.5906409405294477e-03 * rho_inv);
  jac[357] -= (h[15] * (working_temp * jac[373] - (j_temp * (cp[16] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[394] += (spec_rates[15] * mw_avg * -3.9958133926962631e-02 * rho_inv);
  jac[378] -= (h[15] * (working_temp * jac[394] - (j_temp * (cp[17] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[415] += (spec_rates[15] * mw_avg * -7.5753455721406460e-02 * rho_inv);
  jac[399] -= (h[15] * (working_temp * jac[415] - (j_temp * (cp[18] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[436] += (spec_rates[15] * mw_avg * -3.3096623313484702e-01 * rho_inv);
  jac[420] -= (h[15] * (working_temp * jac[436] - (j_temp * (cp[19] - cp[20]) * spec_rates[15] * 3.10342200e+01)));
  jac[38] += (spec_rates[16] * mw_avg * 1.2914946032548331e+01 * rho_inv);
  jac[21] -= (h[16] * (working_temp * jac[38] - (j_temp * (cp[0] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[59] += (spec_rates[16] * mw_avg * 2.6831329944289106e+01 * rho_inv);
  jac[42] -= (h[16] * (working_temp * jac[59] - (j_temp * (cp[1] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[80] += (spec_rates[16] * mw_avg * 7.5198787427330915e-01 * rho_inv);
  jac[63] -= (h[16] * (working_temp * jac[80] - (j_temp * (cp[2] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[101] += (spec_rates[16] * mw_avg * -1.2472500245956830e-01 * rho_inv);
  jac[84] -= (h[16] * (working_temp * jac[101] - (j_temp * (cp[3] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[122] += (spec_rates[16] * mw_avg * 6.4807109751996195e-01 * rho_inv);
  jac[105] -= (h[16] * (working_temp * jac[122] - (j_temp * (cp[4] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[143] += (spec_rates[16] * mw_avg * 5.5578243600665167e-01 * rho_inv);
  jac[126] -= (h[16] * (working_temp * jac[143] - (j_temp * (cp[5] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[164] += (spec_rates[16] * mw_avg * -1.5149753367513644e-01 * rho_inv);
  jac[147] -= (h[16] * (working_temp * jac[164] - (j_temp * (cp[6] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[185] += (spec_rates[16] * mw_avg * 9.9856212080755413e-01 * rho_inv);
  jac[168] -= (h[16] * (working_temp * jac[185] - (j_temp * (cp[7] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[206] += (spec_rates[16] * mw_avg * 9.9856212080755413e-01 * rho_inv);
  jac[189] -= (h[16] * (working_temp * jac[206] - (j_temp * (cp[8] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[227] += (spec_rates[16] * mw_avg * 8.6448136693088651e-01 * rho_inv);
  jac[210] -= (h[16] * (working_temp * jac[227] - (j_temp * (cp[9] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[248] += (spec_rates[16] * mw_avg * 7.4724875577560179e-01 * rho_inv);
  jac[231] -= (h[16] * (working_temp * jac[248] - (j_temp * (cp[10] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[269] += (spec_rates[16] * mw_avg * 1.1011726601251885e-04 * rho_inv);
  jac[252] -= (h[16] * (working_temp * jac[269] - (j_temp * (cp[11] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[290] += (spec_rates[16] * mw_avg * -3.6399440069447486e-01 * rho_inv);
  jac[273] -= (h[16] * (working_temp * jac[290] - (j_temp * (cp[12] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[311] += (spec_rates[16] * mw_avg * -3.4678236842125218e-02 * rho_inv);
  jac[294] -= (h[16] * (working_temp * jac[311] - (j_temp * (cp[13] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[332] += (spec_rates[16] * mw_avg * -6.7130998686435850e-02 * rho_inv);
  jac[315] -= (h[16] * (working_temp * jac[332] - (j_temp * (cp[14] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[353] += (spec_rates[16] * mw_avg * -9.7475736757417525e-02 * rho_inv);
  jac[336] -= (h[16] * (working_temp * jac[353] - (j_temp * (cp[15] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[374] += (spec_rates[16] * mw_avg * -1.4378791924458678e-03 * rho_inv);
  jac[357] -= (h[16] * (working_temp * jac[374] - (j_temp * (cp[16] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[395] += (spec_rates[16] * mw_avg * -3.6120640352322930e-02 * rho_inv);
  jac[378] -= (h[16] * (working_temp * jac[395] - (j_temp * (cp[17] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[416] += (spec_rates[16] * mw_avg * -6.8478256130779624e-02 * rho_inv);
  jac[399] -= (h[16] * (working_temp * jac[416] - (j_temp * (cp[18] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[437] += (spec_rates[16] * mw_avg * -2.9918094517822735e-01 * rho_inv);
  jac[420] -= (h[16] * (working_temp * jac[437] - (j_temp * (cp[19] - cp[20]) * spec_rates[16] * 2.80537600e+01)));
  jac[39] += (spec_rates[17] * mw_avg * 1.3378965497463080e+01 * rho_inv);
  jac[21] -= (h[17] * (working_temp * jac[39] - (j_temp * (cp[0] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[60] += (spec_rates[17] * mw_avg * 2.7795349409203858e+01 * rho_inv);
  jac[42] -= (h[17] * (working_temp * jac[60] - (j_temp * (cp[1] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[81] += (spec_rates[17] * mw_avg * 7.7900595163602415e-01 * rho_inv);
  jac[63] -= (h[17] * (working_temp * jac[81] - (j_temp * (cp[2] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[102] += (spec_rates[17] * mw_avg * -1.2920623132083672e-01 * rho_inv);
  jac[84] -= (h[17] * (working_temp * jac[102] - (j_temp * (cp[3] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[123] += (spec_rates[17] * mw_avg * 6.7135556213483960e-01 * rho_inv);
  jac[105] -= (h[17] * (working_temp * jac[123] - (j_temp * (cp[4] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[144] += (spec_rates[17] * mw_avg * 5.7575107295758254e-01 * rho_inv);
  jac[126] -= (h[17] * (working_temp * jac[144] - (j_temp * (cp[5] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[165] += (spec_rates[17] * mw_avg * -1.5694066942922136e-01 * rho_inv);
  jac[147] -= (h[17] * (working_temp * jac[165] - (j_temp * (cp[6] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[186] += (spec_rates[17] * mw_avg * 1.0344393331329882e+00 * rho_inv);
  jac[168] -= (h[17] * (working_temp * jac[186] - (j_temp * (cp[7] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[207] += (spec_rates[17] * mw_avg * 1.0344393331329882e+00 * rho_inv);
  jac[189] -= (h[17] * (working_temp * jac[207] - (j_temp * (cp[8] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[228] += (spec_rates[17] * mw_avg * 8.9554120878396848e-01 * rho_inv);
  jac[210] -= (h[17] * (working_temp * jac[228] - (j_temp * (cp[9] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[249] += (spec_rates[17] * mw_avg * 7.7409656194833798e-01 * rho_inv);
  jac[231] -= (h[17] * (working_temp * jac[249] - (j_temp * (cp[10] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[270] += (spec_rates[17] * mw_avg * 1.1407365535586027e-04 * rho_inv);
  jac[252] -= (h[17] * (working_temp * jac[270] - (j_temp * (cp[11] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[291] += (spec_rates[17] * mw_avg * -3.7707230954647858e-01 * rho_inv);
  jac[273] -= (h[17] * (working_temp * jac[291] - (j_temp * (cp[12] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[312] += (spec_rates[17] * mw_avg * -3.5924186833949913e-02 * rho_inv);
  jac[294] -= (h[17] * (working_temp * jac[312] - (j_temp * (cp[13] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[333] += (spec_rates[17] * mw_avg * -6.9542939859954356e-02 * rho_inv);
  jac[315] -= (h[17] * (working_temp * jac[333] - (j_temp * (cp[14] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[354] += (spec_rates[17] * mw_avg * -1.0097793019271004e-01 * rho_inv);
  jac[336] -= (h[17] * (working_temp * jac[354] - (j_temp * (cp[15] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[375] += (spec_rates[17] * mw_avg * -1.4895405723547959e-03 * rho_inv);
  jac[357] -= (h[17] * (working_temp * jac[375] - (j_temp * (cp[16] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[396] += (spec_rates[17] * mw_avg * -3.7418414277697654e-02 * rho_inv);
  jac[378] -= (h[17] * (working_temp * jac[396] - (j_temp * (cp[17] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[417] += (spec_rates[17] * mw_avg * -7.0938602746864532e-02 * rho_inv);
  jac[399] -= (h[17] * (working_temp * jac[417] - (j_temp * (cp[18] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[438] += (spec_rates[17] * mw_avg * -3.0993017957258095e-01 * rho_inv);
  jac[420] -= (h[17] * (working_temp * jac[438] - (j_temp * (cp[19] - cp[20]) * spec_rates[17] * 2.90617000e+01)));
  jac[40] += (spec_rates[18] * mw_avg * 1.3842984962377828e+01 * rho_inv);
  jac[21] -= (h[18] * (working_temp * jac[40] - (j_temp * (cp[0] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[61] += (spec_rates[18] * mw_avg * 2.8759368874118604e+01 * rho_inv);
  jac[42] -= (h[18] * (working_temp * jac[61] - (j_temp * (cp[1] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[82] += (spec_rates[18] * mw_avg * 8.0602402899873915e-01 * rho_inv);
  jac[63] -= (h[18] * (working_temp * jac[82] - (j_temp * (cp[2] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[103] += (spec_rates[18] * mw_avg * -1.3368746018210512e-01 * rho_inv);
  jac[84] -= (h[18] * (working_temp * jac[103] - (j_temp * (cp[3] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[124] += (spec_rates[18] * mw_avg * 6.9464002674971725e-01 * rho_inv);
  jac[105] -= (h[18] * (working_temp * jac[124] - (j_temp * (cp[4] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[145] += (spec_rates[18] * mw_avg * 5.9571970990851331e-01 * rho_inv);
  jac[126] -= (h[18] * (working_temp * jac[145] - (j_temp * (cp[5] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[166] += (spec_rates[18] * mw_avg * -1.6238380518330628e-01 * rho_inv);
  jac[147] -= (h[18] * (working_temp * jac[166] - (j_temp * (cp[6] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[187] += (spec_rates[18] * mw_avg * 1.0703165454584220e+00 * rho_inv);
  jac[168] -= (h[18] * (working_temp * jac[187] - (j_temp * (cp[7] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[208] += (spec_rates[18] * mw_avg * 1.0703165454584220e+00 * rho_inv);
  jac[189] -= (h[18] * (working_temp * jac[208] - (j_temp * (cp[8] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[229] += (spec_rates[18] * mw_avg * 9.2660105063705056e-01 * rho_inv);
  jac[210] -= (h[18] * (working_temp * jac[229] - (j_temp * (cp[9] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[250] += (spec_rates[18] * mw_avg * 8.0094436812107428e-01 * rho_inv);
  jac[231] -= (h[18] * (working_temp * jac[250] - (j_temp * (cp[10] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[271] += (spec_rates[18] * mw_avg * 1.1803004469920172e-04 * rho_inv);
  jac[252] -= (h[18] * (working_temp * jac[271] - (j_temp * (cp[11] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[292] += (spec_rates[18] * mw_avg * -3.9015021839848241e-01 * rho_inv);
  jac[273] -= (h[18] * (working_temp * jac[292] - (j_temp * (cp[12] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[313] += (spec_rates[18] * mw_avg * -3.7170136825774594e-02 * rho_inv);
  jac[294] -= (h[18] * (working_temp * jac[313] - (j_temp * (cp[13] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[334] += (spec_rates[18] * mw_avg * -7.1954881033472848e-02 * rho_inv);
  jac[315] -= (h[18] * (working_temp * jac[334] - (j_temp * (cp[14] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[355] += (spec_rates[18] * mw_avg * -1.0448012362800255e-01 * rho_inv);
  jac[336] -= (h[18] * (working_temp * jac[355] - (j_temp * (cp[15] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[376] += (spec_rates[18] * mw_avg * -1.5412019522637239e-03 * rho_inv);
  jac[357] -= (h[18] * (working_temp * jac[376] - (j_temp * (cp[16] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[397] += (spec_rates[18] * mw_avg * -3.8716188203072384e-02 * rho_inv);
  jac[378] -= (h[18] * (working_temp * jac[397] - (j_temp * (cp[17] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[418] += (spec_rates[18] * mw_avg * -7.3398949362949439e-02 * rho_inv);
  jac[399] -= (h[18] * (working_temp * jac[418] - (j_temp * (cp[18] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
  jac[439] += (spec_rates[18] * mw_avg * -3.2067941396693461e-01 * rho_inv);
  jac[420] -= (h[18] * (working_temp * jac[439] - (j_temp * (cp[19] - cp[20]) * spec_rates[18] * 3.00696400e+01)));
}

