#include "sparse_multiplier.h"

void sparse_multiplier(const double * A, const double * Vm, double* w) {
  w[0] =  A[0] * Vm[0] +  A[21] * Vm[1] +  A[42] * Vm[2] +  A[63] * Vm[3] +  A[84] * Vm[4] +  A[105] * Vm[5] +  A[126] * Vm[6] +  A[147] * Vm[7] +  A[168] * Vm[8] +  A[189] * Vm[9] +  A[210] * Vm[10] +  A[231] * Vm[11] +  A[252] * Vm[12] +  A[273] * Vm[13] +  A[294] * Vm[14] +  A[315] * Vm[15] +  A[336] * Vm[16] +  A[357] * Vm[17] +  A[378] * Vm[18] +  A[399] * Vm[19] +  A[420] * Vm[20];
  w[1] =  A[1] * Vm[0] +  A[22] * Vm[1] +  A[43] * Vm[2] +  A[64] * Vm[3] +  A[85] * Vm[4] +  A[106] * Vm[5] +  A[127] * Vm[6] +  A[148] * Vm[7] +  A[169] * Vm[8] +  A[190] * Vm[9] +  A[211] * Vm[10] +  A[232] * Vm[11] +  A[253] * Vm[12] +  A[274] * Vm[13] +  A[295] * Vm[14] +  A[316] * Vm[15] +  A[337] * Vm[16] +  A[358] * Vm[17] +  A[379] * Vm[18] +  A[400] * Vm[19] +  A[421] * Vm[20];
  w[2] =  A[2] * Vm[0] +  A[23] * Vm[1] +  A[44] * Vm[2] +  A[65] * Vm[3] +  A[86] * Vm[4] +  A[107] * Vm[5] +  A[128] * Vm[6] +  A[149] * Vm[7] +  A[170] * Vm[8] +  A[191] * Vm[9] +  A[212] * Vm[10] +  A[233] * Vm[11] +  A[254] * Vm[12] +  A[275] * Vm[13] +  A[296] * Vm[14] +  A[317] * Vm[15] +  A[338] * Vm[16] +  A[359] * Vm[17] +  A[380] * Vm[18] +  A[401] * Vm[19] +  A[422] * Vm[20];
  w[3] =  A[3] * Vm[0] +  A[24] * Vm[1] +  A[45] * Vm[2] +  A[66] * Vm[3] +  A[87] * Vm[4] +  A[108] * Vm[5] +  A[129] * Vm[6] +  A[150] * Vm[7] +  A[171] * Vm[8] +  A[192] * Vm[9] +  A[213] * Vm[10] +  A[234] * Vm[11] +  A[255] * Vm[12] +  A[276] * Vm[13] +  A[297] * Vm[14] +  A[318] * Vm[15] +  A[339] * Vm[16] +  A[360] * Vm[17] +  A[381] * Vm[18] +  A[402] * Vm[19] +  A[423] * Vm[20];
  w[4] =  A[4] * Vm[0] +  A[25] * Vm[1] +  A[46] * Vm[2] +  A[67] * Vm[3] +  A[88] * Vm[4] +  A[109] * Vm[5] +  A[130] * Vm[6] +  A[151] * Vm[7] +  A[172] * Vm[8] +  A[193] * Vm[9] +  A[214] * Vm[10] +  A[235] * Vm[11] +  A[256] * Vm[12] +  A[277] * Vm[13] +  A[298] * Vm[14] +  A[319] * Vm[15] +  A[340] * Vm[16] +  A[361] * Vm[17] +  A[382] * Vm[18] +  A[403] * Vm[19] +  A[424] * Vm[20];
  w[5] =  A[5] * Vm[0] +  A[26] * Vm[1] +  A[47] * Vm[2] +  A[68] * Vm[3] +  A[89] * Vm[4] +  A[110] * Vm[5] +  A[131] * Vm[6] +  A[152] * Vm[7] +  A[173] * Vm[8] +  A[194] * Vm[9] +  A[215] * Vm[10] +  A[236] * Vm[11] +  A[257] * Vm[12] +  A[278] * Vm[13] +  A[299] * Vm[14] +  A[320] * Vm[15] +  A[341] * Vm[16] +  A[362] * Vm[17] +  A[383] * Vm[18] +  A[404] * Vm[19] +  A[425] * Vm[20];
  w[6] =  A[6] * Vm[0] +  A[27] * Vm[1] +  A[48] * Vm[2] +  A[69] * Vm[3] +  A[90] * Vm[4] +  A[111] * Vm[5] +  A[132] * Vm[6] +  A[153] * Vm[7] +  A[174] * Vm[8] +  A[195] * Vm[9] +  A[216] * Vm[10] +  A[237] * Vm[11] +  A[258] * Vm[12] +  A[279] * Vm[13] +  A[300] * Vm[14] +  A[321] * Vm[15] +  A[342] * Vm[16] +  A[363] * Vm[17] +  A[384] * Vm[18] +  A[405] * Vm[19] +  A[426] * Vm[20];
  w[7] =  A[7] * Vm[0] +  A[28] * Vm[1] +  A[49] * Vm[2] +  A[70] * Vm[3] +  A[91] * Vm[4] +  A[112] * Vm[5] +  A[133] * Vm[6] +  A[154] * Vm[7] +  A[175] * Vm[8] +  A[196] * Vm[9] +  A[217] * Vm[10] +  A[238] * Vm[11] +  A[259] * Vm[12] +  A[280] * Vm[13] +  A[301] * Vm[14] +  A[322] * Vm[15] +  A[343] * Vm[16] +  A[364] * Vm[17] +  A[385] * Vm[18] +  A[406] * Vm[19] +  A[427] * Vm[20];
  w[8] =  A[8] * Vm[0] +  A[29] * Vm[1] +  A[50] * Vm[2] +  A[71] * Vm[3] +  A[92] * Vm[4] +  A[113] * Vm[5] +  A[134] * Vm[6] +  A[155] * Vm[7] +  A[176] * Vm[8] +  A[197] * Vm[9] +  A[218] * Vm[10] +  A[239] * Vm[11] +  A[260] * Vm[12] +  A[281] * Vm[13] +  A[302] * Vm[14] +  A[323] * Vm[15] +  A[344] * Vm[16] +  A[365] * Vm[17] +  A[386] * Vm[18] +  A[407] * Vm[19] +  A[428] * Vm[20];
  w[9] =  A[9] * Vm[0] +  A[30] * Vm[1] +  A[51] * Vm[2] +  A[72] * Vm[3] +  A[93] * Vm[4] +  A[114] * Vm[5] +  A[135] * Vm[6] +  A[156] * Vm[7] +  A[177] * Vm[8] +  A[198] * Vm[9] +  A[219] * Vm[10] +  A[240] * Vm[11] +  A[261] * Vm[12] +  A[282] * Vm[13] +  A[303] * Vm[14] +  A[324] * Vm[15] +  A[345] * Vm[16] +  A[366] * Vm[17] +  A[387] * Vm[18] +  A[408] * Vm[19] +  A[429] * Vm[20];
  w[10] =  A[10] * Vm[0] +  A[31] * Vm[1] +  A[52] * Vm[2] +  A[73] * Vm[3] +  A[94] * Vm[4] +  A[115] * Vm[5] +  A[136] * Vm[6] +  A[157] * Vm[7] +  A[178] * Vm[8] +  A[199] * Vm[9] +  A[220] * Vm[10] +  A[241] * Vm[11] +  A[262] * Vm[12] +  A[283] * Vm[13] +  A[304] * Vm[14] +  A[325] * Vm[15] +  A[346] * Vm[16] +  A[367] * Vm[17] +  A[388] * Vm[18] +  A[409] * Vm[19] +  A[430] * Vm[20];
  w[11] =  A[11] * Vm[0] +  A[32] * Vm[1] +  A[53] * Vm[2] +  A[74] * Vm[3] +  A[95] * Vm[4] +  A[116] * Vm[5] +  A[137] * Vm[6] +  A[158] * Vm[7] +  A[179] * Vm[8] +  A[200] * Vm[9] +  A[221] * Vm[10] +  A[242] * Vm[11] +  A[263] * Vm[12] +  A[284] * Vm[13] +  A[305] * Vm[14] +  A[326] * Vm[15] +  A[347] * Vm[16] +  A[368] * Vm[17] +  A[389] * Vm[18] +  A[410] * Vm[19] +  A[431] * Vm[20];
  w[12] =  A[12] * Vm[0] +  A[33] * Vm[1] +  A[54] * Vm[2] +  A[75] * Vm[3] +  A[96] * Vm[4] +  A[117] * Vm[5] +  A[138] * Vm[6] +  A[159] * Vm[7] +  A[180] * Vm[8] +  A[201] * Vm[9] +  A[222] * Vm[10] +  A[243] * Vm[11] +  A[264] * Vm[12] +  A[285] * Vm[13] +  A[306] * Vm[14] +  A[327] * Vm[15] +  A[348] * Vm[16] +  A[369] * Vm[17] +  A[390] * Vm[18] +  A[411] * Vm[19] +  A[432] * Vm[20];
  w[13] =  A[13] * Vm[0] +  A[34] * Vm[1] +  A[55] * Vm[2] +  A[76] * Vm[3] +  A[97] * Vm[4] +  A[118] * Vm[5] +  A[139] * Vm[6] +  A[160] * Vm[7] +  A[181] * Vm[8] +  A[202] * Vm[9] +  A[223] * Vm[10] +  A[244] * Vm[11] +  A[265] * Vm[12] +  A[286] * Vm[13] +  A[307] * Vm[14] +  A[328] * Vm[15] +  A[349] * Vm[16] +  A[370] * Vm[17] +  A[391] * Vm[18] +  A[412] * Vm[19] +  A[433] * Vm[20];
  w[14] =  A[14] * Vm[0] +  A[35] * Vm[1] +  A[56] * Vm[2] +  A[77] * Vm[3] +  A[98] * Vm[4] +  A[119] * Vm[5] +  A[140] * Vm[6] +  A[161] * Vm[7] +  A[182] * Vm[8] +  A[203] * Vm[9] +  A[224] * Vm[10] +  A[245] * Vm[11] +  A[266] * Vm[12] +  A[287] * Vm[13] +  A[308] * Vm[14] +  A[329] * Vm[15] +  A[350] * Vm[16] +  A[371] * Vm[17] +  A[392] * Vm[18] +  A[413] * Vm[19] +  A[434] * Vm[20];
  w[15] =  A[15] * Vm[0] +  A[36] * Vm[1] +  A[57] * Vm[2] +  A[78] * Vm[3] +  A[99] * Vm[4] +  A[120] * Vm[5] +  A[141] * Vm[6] +  A[162] * Vm[7] +  A[183] * Vm[8] +  A[204] * Vm[9] +  A[225] * Vm[10] +  A[246] * Vm[11] +  A[267] * Vm[12] +  A[288] * Vm[13] +  A[309] * Vm[14] +  A[330] * Vm[15] +  A[351] * Vm[16] +  A[372] * Vm[17] +  A[393] * Vm[18] +  A[414] * Vm[19] +  A[435] * Vm[20];
  w[16] =  A[16] * Vm[0] +  A[37] * Vm[1] +  A[58] * Vm[2] +  A[79] * Vm[3] +  A[100] * Vm[4] +  A[121] * Vm[5] +  A[142] * Vm[6] +  A[163] * Vm[7] +  A[184] * Vm[8] +  A[205] * Vm[9] +  A[226] * Vm[10] +  A[247] * Vm[11] +  A[268] * Vm[12] +  A[289] * Vm[13] +  A[310] * Vm[14] +  A[331] * Vm[15] +  A[352] * Vm[16] +  A[373] * Vm[17] +  A[394] * Vm[18] +  A[415] * Vm[19] +  A[436] * Vm[20];
  w[17] =  A[17] * Vm[0] +  A[38] * Vm[1] +  A[59] * Vm[2] +  A[80] * Vm[3] +  A[101] * Vm[4] +  A[122] * Vm[5] +  A[143] * Vm[6] +  A[164] * Vm[7] +  A[185] * Vm[8] +  A[206] * Vm[9] +  A[227] * Vm[10] +  A[248] * Vm[11] +  A[269] * Vm[12] +  A[290] * Vm[13] +  A[311] * Vm[14] +  A[332] * Vm[15] +  A[353] * Vm[16] +  A[374] * Vm[17] +  A[395] * Vm[18] +  A[416] * Vm[19] +  A[437] * Vm[20];
  w[18] =  A[18] * Vm[0] +  A[39] * Vm[1] +  A[60] * Vm[2] +  A[81] * Vm[3] +  A[102] * Vm[4] +  A[123] * Vm[5] +  A[144] * Vm[6] +  A[165] * Vm[7] +  A[186] * Vm[8] +  A[207] * Vm[9] +  A[228] * Vm[10] +  A[249] * Vm[11] +  A[270] * Vm[12] +  A[291] * Vm[13] +  A[312] * Vm[14] +  A[333] * Vm[15] +  A[354] * Vm[16] +  A[375] * Vm[17] +  A[396] * Vm[18] +  A[417] * Vm[19] +  A[438] * Vm[20];
  w[19] =  A[19] * Vm[0] +  A[40] * Vm[1] +  A[61] * Vm[2] +  A[82] * Vm[3] +  A[103] * Vm[4] +  A[124] * Vm[5] +  A[145] * Vm[6] +  A[166] * Vm[7] +  A[187] * Vm[8] +  A[208] * Vm[9] +  A[229] * Vm[10] +  A[250] * Vm[11] +  A[271] * Vm[12] +  A[292] * Vm[13] +  A[313] * Vm[14] +  A[334] * Vm[15] +  A[355] * Vm[16] +  A[376] * Vm[17] +  A[397] * Vm[18] +  A[418] * Vm[19] +  A[439] * Vm[20];
  w[20] =  A[20] * Vm[0] +  A[41] * Vm[1] +  A[62] * Vm[2] +  A[83] * Vm[3] +  A[104] * Vm[4] +  A[125] * Vm[5] +  A[146] * Vm[6] +  A[167] * Vm[7] +  A[188] * Vm[8] +  A[209] * Vm[9] +  A[230] * Vm[10] +  A[251] * Vm[11] +  A[272] * Vm[12] +  A[293] * Vm[13] +  A[314] * Vm[14] +  A[335] * Vm[15] +  A[356] * Vm[16] +  A[377] * Vm[17] +  A[398] * Vm[18] +  A[419] * Vm[19] +  A[440] * Vm[20];
}
